

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Simulation with the Shyft API &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Demonstration of SHyFT API implementation of Kalman Filtering on gridded data" href="../grid-pp/gridpp_geopoints.html" />
    <link rel="prev" title="A first simulation with Shyft" href="run_nea_nidelva.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#general-examples">General examples</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../../content/hydrology/getting_started.html#configured-simulation">Configured simulation</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="calibration-configured.html">Running a calibration with SHyFT</a></li>
<li class="toctree-l3"><a class="reference internal" href="simulation-configured.html">Configured Shyft simulations</a></li>
<li class="toctree-l3"><a class="reference internal" href="run_nea_nidelva.html">A first simulation with Shyft</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Simulation with the Shyft API</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#Introduction">Introduction</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#This-notebook-is-guiding-through-the-simulation-process-of-a-catchment.-The-following-steps-are-described:">This notebook is guiding through the simulation process of a catchment. The following steps are described:</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#The-Shyft-Environment">The Shyft Environment</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#2.-Shyft-initialization">2. Shyft initialization</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#Repositories">Repositories</a></li>
<li class="toctree-l5"><a class="reference internal" href="#Creating-a-Shyft-source">Creating a Shyft source</a></li>
<li class="toctree-l5"><a class="reference internal" href="#Look-at-the-data">Look at the data</a></li>
<li class="toctree-l5"><a class="reference internal" href="#Create-api.TimeSeries">Create api.TimeSeries</a></li>
<li class="toctree-l5"><a class="reference internal" href="#Exploring-the-Shyft-API">Exploring the Shyft API</a><ul>
<li class="toctree-l6"><a class="reference internal" href="#The-concept-of-Shyft-repositories">The concept of Shyft repositories</a></li>
<li class="toctree-l6"><a class="reference internal" href="#The-ARegionEnvironment-class">The ARegionEnvironment class</a></li>
<li class="toctree-l6"><a class="reference internal" href="#Interpolation-Parameters">Interpolation Parameters</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="#Initialization-of-the-region_model">Initialization of the region_model</a><ul>
<li class="toctree-l6"><a class="reference internal" href="#Summary">Summary</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#advanced-tools">Advanced tools</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../content/hydrology/getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Simulation with the Shyft API</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/nea-example/advanced_simulation.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Simulation-with-the-Shyft-API">
<h1>Simulation with the Shyft API<a class="headerlink" href="#Simulation-with-the-Shyft-API" title="Permalink to this headline">¶</a></h1>
<div class="section" id="Introduction">
<h2>Introduction<a class="headerlink" href="#Introduction" title="Permalink to this headline">¶</a></h2>
<p>In <a class="reference internal" href="run_nea_nidelva.html"><span class="doc">Part I</span></a> of the simulation tutorials, we covered conducting a very simple simulation of an example catchment using configuration files. This is a typical use case, but assumes that you have a model well configured and ready for simulation. In practice, one is likely to be interested in exploring different models, configurations, and data sources. Shyft provides a set of tools to conduct this type of analysis, known as the “multiple working model” hypothesis.</p>
<p>This is in fact a key idea of Shyft – to make it simple to evaluate the impact of the selection of model routine (or forcing data) on the performance of the simulation. In this notebook we walk through a lower level paradigm of working with the toolbox and using the Shyft API directly to conduct the simulations.</p>
<div class="section" id="This-notebook-is-guiding-through-the-simulation-process-of-a-catchment.-The-following-steps-are-described:">
<h3>This notebook is guiding through the simulation process of a catchment. The following steps are described:<a class="headerlink" href="#This-notebook-is-guiding-through-the-simulation-process-of-a-catchment.-The-following-steps-are-described:" title="Permalink to this headline">¶</a></h3>
<ol class="arabic simple">
<li><p><strong>Loading required python modules and setting path to SHyFT installation</strong></p></li>
<li><p><strong>Shyft initialization</strong></p></li>
<li><p><strong>Running a Shyft simulation with updated parameters</strong></p></li>
<li><p><strong>Activating the simulation only for selected catchments</strong></p></li>
<li><p><strong>Setting up different input datasets</strong></p></li>
<li><p><strong>Changing state collection settings</strong></p></li>
<li><p><strong>Post processing and extracting results</strong></p></li>
</ol>
</div>
</div>
<div class="section" id="1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">
<h2>1. Loading required python modules and setting path to SHyFT installation<a class="headerlink" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation" title="Permalink to this headline">¶</a></h2>
<p>Shyft requires a number of different modules to be loaded as part of the package. Below, we describe the required steps for loading the modules, and note that some steps are only required for the use of the jupyter notebook.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Pure python modules and jupyter notebook functionality</span>
<span class="c1"># first you should import the third-party python modules which you&#39;ll use later on</span>
<span class="c1"># the first line enables that figures are shown inline, directly in the notebook</span>
<span class="o">%</span><span class="k">matplotlib</span> inline
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">datetime</span> <span class="k">as</span> <span class="nn">dt</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">netCDF4</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="kn">from</span> <span class="nn">os</span> <span class="kn">import</span> <span class="n">path</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>
</pre></div>
</div>
</div>
<div class="section" id="The-Shyft-Environment">
<h3>The Shyft Environment<a class="headerlink" href="#The-Shyft-Environment" title="Permalink to this headline">¶</a></h3>
<p>This next step is highly specific on how and where you have installed Shyft. If you have followed the guidelines at github, and cloned the three shyft repositories: i) shyft, ii) shyft-data, and iii) shyft-doc, then you may need to tell jupyter notebooks where to find shyft. Uncomment the relevant lines below.</p>
<p>If you have a ‘system’ shyft, or used <code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">install</span> <span class="pre">-s</span> <span class="pre">sigbjorn</span> <span class="pre">shyft</span></code> to install shyft, then you probably will want to make sure you have set the SHYFT_DATA directory correctly, as otherwise, Shyft will assume the above structure and fail. <strong>This has to be done before ``import shyft``</strong>. In that case, uncomment the relevant lines below.</p>
<p><strong>note</strong>: it is most likely that you’ll need to do one or the other.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># try to auto-configure the path, -will work in all cases where doc and data</span>
<span class="c1"># are checked out at same level</span>
<span class="n">shyft_data_path</span> <span class="o">=</span> <span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;../../../shyft-data&quot;</span><span class="p">)</span>
<span class="k">if</span> <span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">shyft_data_path</span><span class="p">)</span> <span class="ow">and</span> <span class="s1">&#39;SHYFT_DATA&#39;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">[</span><span class="s1">&#39;SHYFT_DATA&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">shyft_data_path</span>

<span class="c1"># shyft should be available either by it&#39;s install in python</span>
<span class="c1"># or by PYTHONPATH set by user prior to starting notebook.</span>
<span class="c1"># This is equivalent to the two lines below</span>
<span class="c1"># shyft_path=path.abspath(&#39;../../../shyft&#39;)</span>
<span class="c1"># sys.path.insert(0,shyft_path)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Shyft imports</span>
<span class="kn">from</span> <span class="nn">shyft</span> <span class="kn">import</span> <span class="n">api</span>

</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="2.-Shyft-initialization">
<h2>2. Shyft initialization<a class="headerlink" href="#2.-Shyft-initialization" title="Permalink to this headline">¶</a></h2>
<p>In <a class="reference internal" href="run_nea_nidelva.html"><span class="doc">Part I</span></a> we used the <code class="docutils literal notranslate"><span class="pre">YAMLSimConfig</span></code> to read information regarding a preconfigured case. The configuration data for this case was stored in <code class="docutils literal notranslate"><span class="pre">.yaml</span></code> files. In this tutorial, we will walk through the process of using Shyft directly from the <code class="docutils literal notranslate"><span class="pre">shyft.api</span></code> and loading data from scratch. We will use the same dataset as an example. The data is stored in the <a class="reference external" href="https://github.com/statkraft/shyft-data">shyft-data</a> repository, so you must be sure to have cloned that in a
parallel directory to <a class="reference external" href="https://github.com/statkraft/shyft-doc">shyft-doc</a>.</p>
<p>We can review the <a class="reference internal" href="run_nea_nidelva.html#2.-Configuration-of-a-SHyFT-simulation"><span class="std std-ref">yaml configuration files</span></a> from first tutorial. In particular, let’s start by looking at the <a class="reference external" href="nea-config/neanidelva_datasets.yaml">datasets_config_file</a> which points to our data. Let’s just look at a part of this file under the <code class="docutils literal notranslate"><span class="pre">sources</span></code> stanza:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>sources:
- repository: !!python/name:shyft.repository.netcdf.cf_geo_ts_repository.CFDataRepository
  types:
    - precipitation
  params:
    stations_met: ../shyft-data/netcdf/orchestration-testdata/precipitation.nc
    selection_criteria: null
</pre></div>
</div>
<p>As described earlier, <a class="reference internal" href="run_nea_nidelva.html#2.-Configuration-of-a-SHyFT-simulation"><span class="std std-ref">yaml configuration files</span></a> provide a great deal of flexibility to configure runs, and save information. This particular example is showing one repository within the file for the <code class="docutils literal notranslate"><span class="pre">type</span></code> “precipitation”. In this tutorial, we’re simply interested in the path for the data. Looking at the file you’ll see all data sets are stored within:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>../shyft-data/netcdf/orchestration-testdata/
</pre></div>
</div>
<p>Recall that we have either set above, or from installation, have a <code class="docutils literal notranslate"><span class="pre">SHYFT_DATA</span></code> environment variable. This is still where our data is stored for this example. Next we can use this variable and read in the actually precipitation data using a pure (netCDF4) python approach. <strong>Note</strong> <em>we continue to work with the example netcdf files, but one could easily use their own data here as well</em></p>
<div class="section" id="Repositories">
<h3>Repositories<a class="headerlink" href="#Repositories" title="Permalink to this headline">¶</a></h3>
<p>To use Shyft efficiently, one should familiarize themselves with the concept of <a class="reference external" href="repositories.rst">repositories</a>. Briefly, here, we’ll borrow some of the functions in our example repository used to read the netcdf data. Hopefully, between the examples here, and the information provided in the <a class="reference external" href="repositories.rst">repositories</a> section, you’ll gain enough understanding to start to write <em>your own</em> respositories for <em>your</em> data.</p>
<p>Again, refering to the <code class="docutils literal notranslate"><span class="pre">sources</span></code> stanza above, note that the first key is in fact <code class="docutils literal notranslate"><span class="pre">repository</span></code> and directs a user to the class that is used to read the data: <code class="docutils literal notranslate"><span class="pre">CFDataRepository</span></code>. This repository provides more functionality than is required for the example here, for example, for sub-setting data. However, once you have completed this tutorial it is a good idea to take a look at the <code class="docutils literal notranslate"><span class="pre">CFDataRepository</span></code> to gain an understanding of how they work.</p>
<p>But first, let’s read that precipitation data…</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>

<span></span><span class="c1"># now let&#39;s read the &#39;precipitation.nc&#39; file into our workspace using a netCDF4 Dataset</span>
<span class="n">data_directory</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">[</span><span class="s1">&#39;SHYFT_DATA&#39;</span><span class="p">],</span> <span class="s1">&#39;netcdf/orchestration-testdata/&#39;</span><span class="p">)</span>
<span class="n">precipitation</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">data_directory</span><span class="p">,</span> <span class="s1">&#39;precipitation.nc&#39;</span><span class="p">))</span>

<span class="c1"># explore the prec object to see what variables it contains.</span>
<span class="nb">print</span><span class="p">(</span><span class="n">precipitation</span><span class="p">)</span>

</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;class &#39;netCDF4._netCDF4.Dataset&#39;&gt;
root group (NETCDF4 data model, file format HDF5):
    dimensions(sizes): time(8760), station(10)
    variables(dimensions): float64 <span class="ansi-underline">time</span>(time), &lt;class &#39;str&#39;&gt; <span class="ansi-underline">series_name</span>(station), float64 <span class="ansi-underline">x</span>(station), float64 <span class="ansi-underline">y</span>(station), float64 <span class="ansi-underline">z</span>(station), int32 <span class="ansi-underline">crs</span>(), float64 <span class="ansi-underline">precipitation</span>(time,station)
    groups:

</pre></div></div>
</div>
<p>The way we have structured the example datasets is to have a single netcdf file for each variable (e.g. precipitation, temperature, etc.) and a collection of stations within each file. The file has dimensions of <code class="docutils literal notranslate"><span class="pre">time</span></code> and <code class="docutils literal notranslate"><span class="pre">station</span></code>, where station is a unique id. The variables are <code class="docutils literal notranslate"><span class="pre">time</span></code>, <code class="docutils literal notranslate"><span class="pre">series_name</span></code>, <code class="docutils literal notranslate"><span class="pre">x</span></code>, <code class="docutils literal notranslate"><span class="pre">y</span></code>, <code class="docutils literal notranslate"><span class="pre">z</span></code> to give coordinates of the station. In addition we use a <code class="docutils literal notranslate"><span class="pre">crs</span></code> which is a code used to identify the coordinate system used. This is the approach of the example, you
may use whatever works for you to keep your geolocation data coordinated. Lastly, the variable <code class="docutils literal notranslate"><span class="pre">precipitation</span></code> contains the precipitation data.</p>
</div>
<div class="section" id="Creating-a-Shyft-source">
<h3>Creating a Shyft source<a class="headerlink" href="#Creating-a-Shyft-source" title="Permalink to this headline">¶</a></h3>
<p>In Shyft we have the concept of a <code class="docutils literal notranslate"><span class="pre">source</span></code>. The idea is that a <code class="docutils literal notranslate"><span class="pre">source</span></code> provides data to the simulation. Every cell in the <code class="docutils literal notranslate"><span class="pre">region</span></code> contains an <code class="docutils literal notranslate"><span class="pre">env_ts</span></code> attribute, which is a collection of the forcing time series. Currently, environmental time series include:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>precipitation
temperature
rel_hum
radiation
wind_speed
</pre></div>
</div>
<p>These are the forcing variables required for simulation using the existing algorithms, and for each one there is a Shyft <code class="docutils literal notranslate"><span class="pre">source</span></code> type. The cells get populated with these forcing data through an interpolation step. This is true both for point time series data or gridded forcing data. In the latter case, the interpolation treats each grid cell as a ‘station’. Improvements to this approach are on the development roadmap.</p>
<p>We now need to take our time series data read in from the netcdf file, and create <code class="docutils literal notranslate"><span class="pre">api.PrecipitationSource</span></code> which also requires that we convert our raw numpy time series into <code class="docutils literal notranslate"><span class="pre">api.TimeSeries</span></code>. The following steps may seem complex, and some may wonder why not work with plain numpy. The reason is for efficiency. Shyft is optimized using specialized data types. We use the <code class="docutils literal notranslate"><span class="pre">api.TimeSeries</span></code> in order to assure robust and efficient underlying calculations.</p>
<p>We will work through a full example for precipitation, and then rely on a repository to load the rest of our data.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># prec contains all the precipitation forcing data we&#39;ll use:</span>
<span class="n">x</span> <span class="o">=</span> <span class="n">precipitation</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;x&#39;</span><span class="p">]</span>
<span class="n">y</span> <span class="o">=</span> <span class="n">precipitation</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;y&#39;</span><span class="p">]</span>
<span class="n">z</span> <span class="o">=</span> <span class="n">precipitation</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;z&#39;</span><span class="p">]</span>
<span class="n">crs</span> <span class="o">=</span> <span class="n">precipitation</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;crs&#39;</span><span class="p">]</span>
<span class="n">time</span> <span class="o">=</span> <span class="n">precipitation</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;time&#39;</span><span class="p">]</span>
<span class="n">prec</span> <span class="o">=</span> <span class="n">precipitation</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;precipitation&#39;</span><span class="p">]</span>
<span class="n">names</span> <span class="o">=</span> <span class="n">precipitation</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;series_name&#39;</span><span class="p">]</span>
<span class="nb">print</span><span class="p">(</span><span class="n">prec</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="n">time</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;class &#39;netCDF4._netCDF4.Variable&#39;&gt;
float64 precipitation(time, station)
    coordinates: y x z
    units: mm
    grid_mapping: crs
unlimited dimensions:
current shape = (8760, 10)
filling on, default _FillValue of 9.969209968386869e+36 used

&lt;class &#39;netCDF4._netCDF4.Variable&#39;&gt;
float64 time(time)
    units: seconds since 1970-01-01 00:00:00 +00:00
unlimited dimensions:
current shape = (8760,)
filling on, default _FillValue of 9.969209968386869e+36 used

</pre></div></div>
</div>
<p>You can explore further all the individual variables, but take note that the <code class="docutils literal notranslate"><span class="pre">p</span></code> variable has all the metadata required for geolocation as well as units. Further it contains 10 stations with 8760 points. Also note that the <code class="docutils literal notranslate"><span class="pre">time</span></code> variable contains a units definition which we will use.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">netcdftime</span> <span class="kn">import</span> <span class="n">utime</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>

<span class="sd">&quot;&quot;&quot; These are the current supported regular time-step intervals &quot;&quot;&quot;</span>
<span class="n">delta_t_dic</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;days&#39;</span><span class="p">:</span> <span class="n">api</span><span class="o">.</span><span class="n">deltahours</span><span class="p">(</span><span class="mi">24</span><span class="p">),</span> <span class="s1">&#39;hours&#39;</span><span class="p">:</span> <span class="n">api</span><span class="o">.</span><span class="n">deltahours</span><span class="p">(</span><span class="mi">1</span><span class="p">),</span> <span class="s1">&#39;minutes&#39;</span><span class="p">:</span> <span class="n">api</span><span class="o">.</span><span class="n">deltaminutes</span><span class="p">(</span><span class="mi">1</span><span class="p">),</span>
               <span class="s1">&#39;seconds&#39;</span><span class="p">:</span> <span class="n">api</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">SECOND</span><span class="p">}</span>


<span class="k">def</span> <span class="nf">convert_netcdf_time</span><span class="p">(</span><span class="n">time_spec</span><span class="p">:</span><span class="nb">str</span><span class="p">,</span> <span class="n">t</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Converts supplied numpy array to  shyft utctime given netcdf time_spec.</span>
<span class="sd">    Throws exception if time-unit is not supported, i.e. not part of delta_t_dic</span>
<span class="sd">    as specified in this file.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">        time_spec: string</span>
<span class="sd">           from netcdef  like &#39;hours since 1970-01-01 00:00:00&#39;</span>
<span class="sd">        t: numpy array</span>
<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">        numpy array type int64 with new shyft utctime units (seconds since 1970utc)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">u</span> <span class="o">=</span> <span class="n">utime</span><span class="p">(</span><span class="n">time_spec</span><span class="p">)</span>
    <span class="n">t_origin</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">Calendar</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">u</span><span class="o">.</span><span class="n">tzoffset</span><span class="p">))</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="n">u</span><span class="o">.</span><span class="n">origin</span><span class="o">.</span><span class="n">year</span><span class="p">,</span> <span class="n">u</span><span class="o">.</span><span class="n">origin</span><span class="o">.</span><span class="n">month</span><span class="p">,</span> <span class="n">u</span><span class="o">.</span><span class="n">origin</span><span class="o">.</span><span class="n">day</span><span class="p">,</span> <span class="n">u</span><span class="o">.</span><span class="n">origin</span><span class="o">.</span><span class="n">hour</span><span class="p">,</span> <span class="n">u</span><span class="o">.</span><span class="n">origin</span><span class="o">.</span><span class="n">minute</span><span class="p">,</span> <span class="n">u</span><span class="o">.</span><span class="n">origin</span><span class="o">.</span><span class="n">second</span><span class="p">)</span>
    <span class="c1">#print (t[0],t_origin,delta_t_dic[u.units])</span>
    <span class="n">delta_t</span> <span class="o">=</span> <span class="n">delta_t_dic</span><span class="p">[</span><span class="n">u</span><span class="o">.</span><span class="n">units</span><span class="p">]</span>
    <span class="c1">#return (t_origin + delta_t * t[:]).astype(np.int64)</span>
    <span class="k">return</span> <span class="n">t_origin</span> <span class="o">+</span> <span class="n">delta_t</span> <span class="o">*</span> <span class="n">t</span><span class="p">[:]</span><span class="o">.</span><span class="n">astype</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">int64</span><span class="p">)</span>

<span class="c1"># note, the above could have simply been imported:</span>
<span class="kn">from</span> <span class="nn">shyft.repository.netcdf.time_conversion</span> <span class="kn">import</span> <span class="n">convert_netcdf_time</span> <span class="k">as</span> <span class="n">cnt</span>


</pre></div>
</div>
</div>
<p>Note that in this example, the two values are the same. However, using shyft utctime we assure we keep track of the timezone. If your netcdf time.units attribute is different, Shyft will make the converstion into utctime.</p>
</div>
<div class="section" id="Look-at-the-data">
<h3>Look at the data<a class="headerlink" href="#Look-at-the-data" title="Permalink to this headline">¶</a></h3>
<p>Before proceeding, we’ll take a quick look at our precipitation data to assure it is as we expect.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span> <span class="mi">6</span><span class="p">))</span>

<span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">name</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">names</span><span class="p">):</span>
    <span class="n">y</span> <span class="o">=</span> <span class="n">prec</span><span class="p">[:,</span><span class="n">i</span><span class="p">]</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">time</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="n">name</span><span class="p">)</span>


<span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s1">&#39;10 Precipitation Stations&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;Precipitation [mm]&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;UTC Time [seconds since 1970-0-0]&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/home/sih/projects/miniconda/envs/shyft_env/lib/python3.6/site-packages/ipykernel_launcher.py:4: RuntimeWarning: invalid value encountered in greater
  after removing the cwd from sys.path.
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;matplotlib.legend.Legend at 0x7ff958752128&gt;
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_advanced_simulation_13_2.png" src="../../_images/notebooks_nea-example_advanced_simulation_13_2.png" />
</div>
</div>
</div>
<div class="section" id="Create-api.TimeSeries">
<h3>Create api.TimeSeries<a class="headerlink" href="#Create-api.TimeSeries" title="Permalink to this headline">¶</a></h3>
<p>Now, we have the data and time, or index value. Next we will create a Shyft object type, <code class="docutils literal notranslate"><span class="pre">shyft.api.TimeSeries</span></code>. To the uninitiated, this step may feel complex. In actuality it is a simple step and enables a great deal of underlying functionality within Shyft.</p>
<p>We’ll extract the data from the netcdf file and work with the individual data series.</p>
<p><strong>NOTE</strong> the purpose here is to demonstrate the details, and is a <strong>very inefficient</strong> way to work. As stated previously, normally one would write their own repository to conduct all of this ‘under the covers’ using optimized python tools (e.g. xarray, numpy, etc.). The point here is that in the next steps, you can see how to work with individual data series that you may have read into python from, say for example, a <em>ahem</em> text file.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># we&#39;ll start by creating a time_axis:</span>
<span class="c1"># help(api.TimeAxis)</span>
<span class="n">t</span> <span class="o">=</span> <span class="n">time</span><span class="p">[:]</span>
<span class="c1"># get the end time of the last interval as an integer:</span>
<span class="n">end_t</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="mi">2</span><span class="o">*</span><span class="n">t</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">t</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">])</span>

<span class="c1"># create a time_axis for the simulation</span>
<span class="n">time_axis</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">UtcTimeVector</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">t</span><span class="o">.</span><span class="n">astype</span><span class="p">(</span><span class="nb">int</span><span class="p">)),</span> <span class="n">end_t</span><span class="p">)</span>
<span class="c1"># here we used the call structure: __init__( (object)arg1, (UtcTimeVector)time_points, (int)t_end) -&gt; None</span>
<span class="c1"># creates a time-axis by specifying the time_points and t-end of the last interval</span>


<span class="c1"># next convert data time series into Shyft.api.TimeSeries objects:</span>
<span class="n">p0</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">time_axis</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">DoubleVector</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">prec</span><span class="p">[:,</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">flatten</span><span class="p">()),</span> <span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>

</pre></div>
</div>
</div>
</div>
<div class="section" id="Exploring-the-Shyft-API">
<h3>Exploring the Shyft API<a class="headerlink" href="#Exploring-the-Shyft-API" title="Permalink to this headline">¶</a></h3>
<p>In the following section we’ll explore several components of the <code class="docutils literal notranslate"><span class="pre">shyft.api</span></code>. We consider the strength of Shyft to lie within this Application Programming Interface, or API. To the uninitiated, it adds quite a degree of complexity. However, once you understand the different components and paradigms of Shyft, you’ll see the flexibility the API offers provides a great number of possibilities for exploring hydrologic simulations.</p>
<p>The API approach will take a bit more code to get started, but will allow great flexibility later on.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># get the simulator from yaml</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.configuration.yaml_configs</span> <span class="kn">import</span> <span class="n">YAMLSimConfig</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.simulators.config_simulator</span> <span class="kn">import</span> <span class="n">ConfigSimulator</span>
<span class="n">config_file_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;./nea-config/neanidelva_simulation.yaml&quot;</span><span class="p">)</span>
<span class="n">cfg</span> <span class="o">=</span> <span class="n">YAMLSimConfig</span><span class="p">(</span><span class="n">config_file_path</span><span class="p">,</span> <span class="s2">&quot;neanidelva&quot;</span><span class="p">)</span>
<span class="n">simulator</span> <span class="o">=</span> <span class="n">ConfigSimulator</span><span class="p">(</span><span class="n">cfg</span><span class="p">)</span>
<span class="c1">#</span>
<span class="n">region_model</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span>
<span class="n">region_model_id</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model_id</span>
<span class="n">interpolation_id</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">interpolation_id</span>
</pre></div>
</div>
</div>
<p>In the <a class="reference internal" href="run_nea_nidelva.html#The-simulator-and-the-region_model"><span class="std std-ref">first tutorial</span></a> we discussed the <code class="docutils literal notranslate"><span class="pre">region_model</span></code>. If you are unfamiliar with this class, we recommend reviewing the <a class="reference external" href="region_model.rst">description</a>.</p>
<div class="section" id="The-concept-of-Shyft-repositories">
<h4>The concept of Shyft repositories<a class="headerlink" href="#The-concept-of-Shyft-repositories" title="Permalink to this headline">¶</a></h4>
<p>In Shyft, we consider that input data is a “source”. Our source data resides in some kind of data serialization… be it a text file, netcdf file, or database… One could have any kind of storage format for the source data. <a class="reference external" href="repositories.rst">Repositories</a> are Python based interfaces to data. Several have been created within Shyft already, but users are encouraged to create their own. A guiding paradigm to Shyft is that data should live as close to the source as possible (ideally, at the
source). The repositories connect to the data source and make the data available to Shyft.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># expose the repositories</span>
<span class="n">region_model_repo</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model_repository</span>
<span class="n">interpolation_param_repo</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">ip_repos</span>
<span class="n">geo_ts_repo</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">geo_ts_repository</span>
<span class="n">initial_state_repo</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">initial_state_repo</span>
</pre></div>
</div>
</div>
<p>Now we have exposed the <strong>repositories</strong> that we connected to our <code class="docutils literal notranslate"><span class="pre">region_model</span></code> during configuration. Having access to the repositories, means that we have access to the input data sources directly (found in <code class="docutils literal notranslate"><span class="pre">geo_ts_repository</span></code>). We also have several other repositories, including a repository for the interpolation parameters, initial state, and the region_model. We’ll explore some of these a bit deeper now. But first we’ll expose a few more pieces of information from the region_model while
we’re at it.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">epsg</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">bounding_region</span><span class="o">.</span><span class="n">epsg</span><span class="p">()</span>
<span class="n">bbox</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">bounding_region</span><span class="o">.</span><span class="n">bounding_polygon</span><span class="p">(</span><span class="n">epsg</span><span class="p">)</span>
<span class="n">period</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">time_axis</span><span class="o">.</span><span class="n">total_period</span><span class="p">()</span>
<span class="n">geo_ts_names</span> <span class="o">=</span> <span class="p">(</span><span class="s2">&quot;temperature&quot;</span><span class="p">,</span> <span class="s2">&quot;wind_speed&quot;</span><span class="p">,</span> <span class="s2">&quot;precipitation&quot;</span><span class="p">,</span> <span class="s2">&quot;relative_humidity&quot;</span><span class="p">,</span> <span class="s2">&quot;radiation&quot;</span><span class="p">)</span>
<span class="n">sources</span> <span class="o">=</span> <span class="n">geo_ts_repo</span><span class="o">.</span><span class="n">get_timeseries</span><span class="p">(</span><span class="n">geo_ts_names</span><span class="p">,</span> <span class="n">period</span><span class="p">,</span> <span class="n">geo_location_criteria</span><span class="o">=</span><span class="n">bbox</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/home/sih/projects/shyft/shyft/repository/netcdf/utils.py:351: RuntimeWarning: invalid value encountered in greater
  pure_arr = nc_var[data_slice][tuple(xy_slice_mask)]
</pre></div></div>
</div>
<p>The <code class="docutils literal notranslate"><span class="pre">epsg</span></code> is simply the domain projection information for our simulation. <code class="docutils literal notranslate"><span class="pre">bbox</span></code> provides the bounding box coordinates. <code class="docutils literal notranslate"><span class="pre">period</span></code> gives the total period of the simulation. Lastly, we create a tuple of the ‘geolocated timeseries names’ or <code class="docutils literal notranslate"><span class="pre">geo_ts_names</span></code> as it is referred to here. And use this to get the <em>sources</em> out of our repository. Note that these names:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>temperature
wind_speed
precipitation
relative_humidity
radiation
</pre></div>
</div>
<p>Are embedded into Shyft as timeseries names that are required for simulations. In the current implementations, these are the default names used in repositories and, at present, the only forcing data required. If one were to develop new algorithms that reqiured other forcings, you would need to define these in a custom repository. See <code class="docutils literal notranslate"><span class="pre">interfaces.py</span></code> for more details.</p>
<p>Before going further, let’s look at what we have so far…</p>
<p>We won’t look in detail at all the repositories, but let’s take a look at the <code class="docutils literal notranslate"><span class="pre">geo_ts_repo</span></code>:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># explore geo_ts_repo</span>
<span class="c1">#help(geo_ts_repo)</span>
</pre></div>
</div>
</div>
<p>The <code class="docutils literal notranslate"><span class="pre">geo_ts_repo</span></code> is a collection of geolocated timeseries repositories. Note that <code class="docutils literal notranslate"><span class="pre">geo_ts_repo</span></code> has an attribute: <code class="docutils literal notranslate"><span class="pre">.geo_ts_repositories</span></code>… this seems redundant? This is simply a list of the repositories this class is ‘managing’.</p>
<p>Maybe we want to look at the precipitation input series in more detail. We can get at those via this class. NOTE, this may not be the most typical way to look at your input data (presumably you may have already done this before the simulation working with the raw netcdf files), but in case you wish to see the datasets from the “model” perspective, this is how you gain access. Also, maybe you want to conduct a simulation, then make a data correction. You could do that by accessing the values
here. Each of the aforementioned series types have a specialized source vector type in Shyft. In the case of precipitation it is a <code class="docutils literal notranslate"><span class="pre">api.PrecipitationSourceVector</span></code>. If we dig into this, we’ll find some aspects familiar from the first tutorial.</p>
<p>Let’s get the precipitation timeseries out of the repository for the period of the simulation first:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># above we already created a `sources` dictionary by</span>
<span class="c1"># using the `get_timeseries` method. This method takes a</span>
<span class="c1"># list of the timeseries names as input and a period</span>
<span class="c1"># of type &#39;shyft.api._api.UtcPeriod&#39;</span>
<span class="c1"># it returns a dictionary, keyed by the names of the timeseries</span>
<span class="n">prec</span> <span class="o">=</span> <span class="n">sources</span><span class="p">[</span><span class="s1">&#39;precipitation&#39;</span><span class="p">]</span>

<span class="c1"># `prec` is now a `api.PrecipitationSourceVector` and if you look</span>
<span class="c1"># you&#39;ll see it 10 elements:</span>
<span class="nb">print</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">prec</span><span class="p">))</span>

</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
10
</pre></div></div>
</div>
<p>We can explore further and see each element is in itself an <code class="docutils literal notranslate"><span class="pre">api.PrecipitationSource</span></code>, which has a timeseries (ts). Recall from the first tutorial that we can easily convert the <code class="docutils literal notranslate"><span class="pre">timeseries.time_axis</span></code> into datetime values for plotting.</p>
<p>Let’s plot the precip of each of the sources:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">10</span><span class="p">))</span>

<span class="k">for</span> <span class="n">pr</span> <span class="ow">in</span> <span class="n">prec</span><span class="p">:</span>
    <span class="n">t</span><span class="p">,</span><span class="n">p</span> <span class="o">=</span> <span class="p">[</span><span class="n">dt</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">utcfromtimestamp</span><span class="p">(</span><span class="n">t_</span><span class="o">.</span><span class="n">start</span><span class="p">)</span> <span class="k">for</span> <span class="n">t_</span> <span class="ow">in</span> <span class="n">pr</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">time_axis</span><span class="p">],</span> <span class="n">pr</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">t</span><span class="p">,</span><span class="n">p</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="n">pr</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">x</span><span class="p">)</span> <span class="c1">#uid is empty now, but we reserve for later use</span>
<span class="n">fig</span><span class="o">.</span><span class="n">autofmt_xdate</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s2">&quot;Precipitation Input Sources&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;precip[mm/hr]&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/home/sih/projects/miniconda/envs/shyft_env/lib/python3.6/site-packages/pandas/plotting/_converter.py:129: FutureWarning: Using an implicitly registered datetime converter for a matplotlib plotting method. The converter was registered by pandas on import. Future versions of pandas will require you to explicitly register matplotlib converters.

To register the converters:
        &gt;&gt;&gt; from pandas.plotting import register_matplotlib_converters
        &gt;&gt;&gt; register_matplotlib_converters()
  warnings.warn(msg, FutureWarning)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;precip[mm/hr]&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_advanced_simulation_28_2.png" src="../../_images/notebooks_nea-example_advanced_simulation_28_2.png" />
</div>
</div>
<p>Before we leave this section, we can also take a quick look at the <code class="docutils literal notranslate"><span class="pre">interpolation_param_repo</span></code>. This is a different type of repository, and it contains the parameters that will be passed to the interpolation algorithm to take a point-source timeseries and interpolate them to the Shyft cells, or in the context of of the API: <code class="docutils literal notranslate"><span class="pre">region_model.cells</span></code>. We’ll quickly look at the <code class="docutils literal notranslate"><span class="pre">.params</span></code> attribute, which is a dictionary.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[16]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">interpolation_param_repo</span><span class="o">.</span><span class="n">params</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[16]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
{&#39;temperature&#39;: {&#39;method&#39;: &#39;btk&#39;,
  &#39;params&#39;: {&#39;temperature_gradient&#39;: -0.6,
   &#39;temperature_gradient_sd&#39;: 0.25,
   &#39;nug&#39;: 0.5,
   &#39;range&#39;: 200000.0,
   &#39;sill&#39;: 25.0,
   &#39;zscale&#39;: 20.0}},
 &#39;precipitation&#39;: {&#39;method&#39;: &#39;idw&#39;,
  &#39;params&#39;: {&#39;max_distance&#39;: 600000.0,
   &#39;max_members&#39;: 10,
   &#39;distance_measure_factor&#39;: 1,
   &#39;scale_factor&#39;: 1.02}},
 &#39;radiation&#39;: {&#39;method&#39;: &#39;idw&#39;,
  &#39;params&#39;: {&#39;max_distance&#39;: 600000.0,
   &#39;max_members&#39;: 10,
   &#39;distance_measure_factor&#39;: 1.0}},
 &#39;wind_speed&#39;: {&#39;method&#39;: &#39;idw&#39;,
  &#39;params&#39;: {&#39;max_distance&#39;: 600000.0,
   &#39;max_members&#39;: 10,
   &#39;distance_measure_factor&#39;: 1.0}},
 &#39;relative_humidity&#39;: {&#39;method&#39;: &#39;idw&#39;,
  &#39;params&#39;: {&#39;max_distance&#39;: 600000.0,
   &#39;max_members&#39;: 10,
   &#39;distance_measure_factor&#39;: 1.0}}}
</pre></div></div>
</div>
<p>One quickly recognizes the same input source type keywords that are used as keys to the <code class="docutils literal notranslate"><span class="pre">params</span></code> dictionary. <code class="docutils literal notranslate"><span class="pre">params</span></code> is simply a dictionary of dictionaries which contains the parameters used by the interpolation model that is specific for each source type.</p>
<p>In closing, one is encouraged to understand well the concept of the <strong>repositories</strong>. As a user of Shyft, it is likely you’ll want to create your own repository to access your data directly rather than creating input files for Shyft. Keep in mind that the repositories are Python code, and not a part of the core C++ code of Shyft. They are designed to provide an interface between the C++ code and potentially more ‘pythonic’ paradigms. In the following section, you’ll see that we populate a C++
class from a repository collection.</p>
</div>
<div class="section" id="The-ARegionEnvironment-class">
<h4>The ARegionEnvironment class<a class="headerlink" href="#The-ARegionEnvironment-class" title="Permalink to this headline">¶</a></h4>
<p>The next thing we’ll do is to create an <code class="docutils literal notranslate"><span class="pre">api.ARegionEnvironment</span></code> class to use in our custom simulation. As the <code class="docutils literal notranslate"><span class="pre">geo_ts_repo</span></code> was a Python interface that provided a collection of all the timeseries repositories, the <code class="docutils literal notranslate"><span class="pre">region_env</span></code> is an API type that provides a container of the “sources” of data specific to the model. We will now create an <code class="docutils literal notranslate"><span class="pre">api.ARegionEnvironment</span></code> from the <code class="docutils literal notranslate"><span class="pre">geo_ts_repo</span></code>. It may be helpful to think of a <code class="docutils literal notranslate"><span class="pre">region_env</span></code> as the container of input data for the <code class="docutils literal notranslate"><span class="pre">region_model</span></code>
– in fact, that is what it is.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[17]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="k">def</span> <span class="nf">get_region_env</span><span class="p">(</span><span class="n">sources_</span><span class="p">):</span>
    <span class="n">region_env_</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">ARegionEnvironment</span><span class="p">()</span>
    <span class="n">region_env_</span><span class="o">.</span><span class="n">temperature</span> <span class="o">=</span> <span class="n">sources_</span><span class="p">[</span><span class="s2">&quot;temperature&quot;</span><span class="p">]</span>
    <span class="n">region_env_</span><span class="o">.</span><span class="n">precipitation</span> <span class="o">=</span> <span class="n">sources_</span><span class="p">[</span><span class="s2">&quot;precipitation&quot;</span><span class="p">]</span>
    <span class="n">region_env_</span><span class="o">.</span><span class="n">radiation</span> <span class="o">=</span> <span class="n">sources_</span><span class="p">[</span><span class="s2">&quot;radiation&quot;</span><span class="p">]</span>
    <span class="n">region_env_</span><span class="o">.</span><span class="n">wind_speed</span> <span class="o">=</span> <span class="n">sources_</span><span class="p">[</span><span class="s2">&quot;wind_speed&quot;</span><span class="p">]</span>
    <span class="n">region_env_</span><span class="o">.</span><span class="n">rel_hum</span> <span class="o">=</span> <span class="n">sources_</span><span class="p">[</span><span class="s2">&quot;relative_humidity&quot;</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">region_env_</span>

<span class="n">region_env</span> <span class="o">=</span> <span class="n">get_region_env</span><span class="p">(</span><span class="n">sources</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>What we have done here is to convert our input data from the Python based repositories into a C++ type object that is used in the Shyft core. It may feel redundant to <code class="docutils literal notranslate"><span class="pre">geo_ts_repo</span></code>, but there are underlying differences. Still, you’ll see that now the ‘sources’ are direct attributes of the <code class="docutils literal notranslate"><span class="pre">region_env</span></code> class:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">print</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">region_env</span><span class="o">.</span><span class="n">precipitation</span><span class="p">))</span>
<span class="nb">type</span><span class="p">(</span><span class="n">region_env</span><span class="o">.</span><span class="n">precipitation</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
10
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
shyft.api._api.PrecipitationSource
</pre></div></div>
</div>
</div>
<div class="section" id="Interpolation-Parameters">
<h4>Interpolation Parameters<a class="headerlink" href="#Interpolation-Parameters" title="Permalink to this headline">¶</a></h4>
<p>In the same manner that we need to convert the sources from the Python based container, we’ll also create an API object from the <code class="docutils literal notranslate"><span class="pre">interpolation_param_repo</span></code>.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[19]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">interpolation_parameters</span> <span class="o">=</span> <span class="n">interpolation_param_repo</span><span class="o">.</span><span class="n">get_parameters</span><span class="p">(</span><span class="n">interpolation_id</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>Okay, now we are set to <em>rebuild</em> our <code class="docutils literal notranslate"><span class="pre">region_model</span></code> from scratch. In the next few steps we’re going to walk through initialization of the <code class="docutils literal notranslate"><span class="pre">region_model</span></code> to set it up for simulation.</p>
</div>
</div>
<div class="section" id="Initialization-of-the-region_model">
<h3>Initialization of the region_model<a class="headerlink" href="#Initialization-of-the-region_model" title="Permalink to this headline">¶</a></h3>
<p>The two <code class="docutils literal notranslate"><span class="pre">shyft.api</span></code> types: <code class="docutils literal notranslate"><span class="pre">api.ARegionEnvironment</span></code> and <code class="docutils literal notranslate"><span class="pre">api.InterpolationParameter</span></code> together are used to initialize the <code class="docutils literal notranslate"><span class="pre">region_model</span></code>. In the next step, all of the timeseries input sources are interpolated to the geolocated model cells. After this step, each cell is the model has it’s own <code class="docutils literal notranslate"><span class="pre">env_ts</span></code> which contains the timeseries for that cell. Let’s first do the interpolation, the we can explore the <code class="docutils literal notranslate"><span class="pre">region_model.cells</span></code> a bit further.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[20]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1">#region_model.run_interpolation(interpolation_parameters, region_model.time_axis, region_env)</span>
<span class="n">region_model</span><span class="o">.</span><span class="n">interpolate</span><span class="p">(</span><span class="n">interpolation_parameters</span><span class="p">,</span> <span class="n">region_env</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[20]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
True
</pre></div></div>
</div>
<p>Okay, that was simple. Let’s look at the timeseries in some individual cells. The following is a bit of a contrived example, but it shows some aspects of the api. We’ll plot the temperature series of all the cells in one sub-catchment, and color them by elevation.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[21]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">matplotlib.cm</span> <span class="kn">import</span> <span class="n">jet</span> <span class="k">as</span> <span class="n">jet</span>
<span class="kn">from</span> <span class="nn">matplotlib.colors</span> <span class="kn">import</span> <span class="n">Normalize</span>

<span class="c1"># get all the cells for one sub-catchment with &#39;id&#39; == 1228</span>
<span class="n">c1228</span> <span class="o">=</span> <span class="p">[</span><span class="n">c</span> <span class="k">for</span> <span class="n">c</span> <span class="ow">in</span> <span class="n">region_model</span><span class="o">.</span><span class="n">cells</span> <span class="k">if</span> <span class="n">c</span><span class="o">.</span><span class="n">geo</span><span class="o">.</span><span class="n">catchment_id</span><span class="p">()</span> <span class="o">==</span> <span class="mi">1228</span><span class="p">]</span>

<span class="c1"># for plotting, create an mpl normalizer based on min,max elevation</span>
<span class="n">elv</span> <span class="o">=</span> <span class="p">[</span><span class="n">c</span><span class="o">.</span><span class="n">geo</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">z</span> <span class="k">for</span> <span class="n">c</span> <span class="ow">in</span> <span class="n">c1228</span><span class="p">]</span>
<span class="n">norm</span> <span class="o">=</span> <span class="n">Normalize</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">elv</span><span class="p">),</span> <span class="nb">max</span><span class="p">(</span><span class="n">elv</span><span class="p">))</span>

<span class="c1">#plot with line color a function of elevation</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">10</span><span class="p">))</span>

<span class="c1"># here we are cycling through each of the cells in c1228</span>
<span class="k">for</span> <span class="n">dat</span><span class="p">,</span><span class="n">elv</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">([</span><span class="n">c</span><span class="o">.</span><span class="n">env_ts</span><span class="o">.</span><span class="n">temperature</span><span class="o">.</span><span class="n">values</span> <span class="k">for</span> <span class="n">c</span> <span class="ow">in</span> <span class="n">c1228</span><span class="p">],</span> <span class="p">[</span><span class="n">c</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">z</span> <span class="k">for</span> <span class="n">c</span> <span class="ow">in</span> <span class="n">c1228</span><span class="p">]):</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">dat</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="n">jet</span><span class="p">(</span><span class="n">norm</span><span class="p">(</span><span class="n">elv</span><span class="p">)),</span> <span class="n">label</span><span class="o">=</span><span class="nb">int</span><span class="p">(</span><span class="n">elv</span><span class="p">))</span>


<span class="c1"># the following is just to plot the legend entries and not related to Shyft</span>
<span class="n">handles</span><span class="p">,</span> <span class="n">labels</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">get_legend_handles_labels</span><span class="p">()</span>

<span class="c1"># sort by labels</span>
<span class="kn">import</span> <span class="nn">operator</span>
<span class="n">hl</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="nb">zip</span><span class="p">(</span><span class="n">handles</span><span class="p">,</span> <span class="n">labels</span><span class="p">),</span>
            <span class="n">key</span><span class="o">=</span><span class="n">operator</span><span class="o">.</span><span class="n">itemgetter</span><span class="p">(</span><span class="mi">1</span><span class="p">))</span>
<span class="n">handles2</span><span class="p">,</span> <span class="n">labels2</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">hl</span><span class="p">)</span>

<span class="c1"># show legend, but only every fifth entry</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">handles2</span><span class="p">[::</span><span class="mi">5</span><span class="p">],</span> <span class="n">labels2</span><span class="p">[::</span><span class="mi">5</span><span class="p">],</span> <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Elevation [m]&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[21]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;matplotlib.legend.Legend at 0x7ff9556430b8&gt;
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_advanced_simulation_42_1.png" src="../../_images/notebooks_nea-example_advanced_simulation_42_1.png" />
</div>
</div>
<p>As we would expect from the temperature kriging method, we should find higher elevations have colder temperatures. As an exercise you could explore this relationship using a scatter plot.</p>
<p>Now we’re going to create a function that will read initial states from the <code class="docutils literal notranslate"><span class="pre">initial_state_repo</span></code>. In practice, this is already done by the <code class="docutils literal notranslate"><span class="pre">ConfgiSimulator</span></code>, but to demonstrate lower level functions, we’ll reset the states of our <code class="docutils literal notranslate"><span class="pre">region_model</span></code>:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[22]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># create a function to read the states from the state repository</span>
<span class="k">def</span> <span class="nf">get_init_state_from_repo</span><span class="p">(</span><span class="n">initial_state_repo_</span><span class="p">,</span> <span class="n">region_model_id_</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">timestamp</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
    <span class="n">states</span> <span class="o">=</span> <span class="n">initial_state_repo_</span><span class="o">.</span><span class="n">find_state</span><span class="p">(</span>
        <span class="n">region_model_id_criteria</span><span class="o">=</span><span class="n">region_model_id_</span><span class="p">,</span>
        <span class="n">utc_timestamp_criteria</span><span class="o">=</span><span class="n">timestamp</span><span class="p">)</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">states</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
        <span class="n">state_id</span> <span class="o">=</span> <span class="n">states</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">state_id</span>  <span class="c1"># most_recent_state i.e. &lt;= start time</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s1">&#39;No initial state matching criteria.&#39;</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">initial_state_repo_</span><span class="o">.</span><span class="n">get_state</span><span class="p">(</span><span class="n">state_id</span><span class="p">)</span>

<span class="n">init_state</span> <span class="o">=</span> <span class="n">get_init_state_from_repo</span><span class="p">(</span><span class="n">initial_state_repo</span><span class="p">,</span> <span class="n">region_model_id_</span><span class="o">=</span><span class="n">region_model_id</span><span class="p">,</span> <span class="n">timestamp</span><span class="o">=</span><span class="n">region_model</span><span class="o">.</span><span class="n">time_axis</span><span class="o">.</span><span class="n">start</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>Don’t worry too much about the function for now, but do take note of the <code class="docutils literal notranslate"><span class="pre">init_state</span></code> object that we created. This is another container, this time it is a class that contains <code class="docutils literal notranslate"><span class="pre">PTGSKStateWithId</span></code> objects, which are specific to the model stack implemented in the simulation (in this case <code class="docutils literal notranslate"><span class="pre">PTGSK</span></code>). If we explore an individual state object, we’ll see <code class="docutils literal notranslate"><span class="pre">init_state</span></code> contains, for each cell in our simulation, the state variables for each ‘method’ of the method stack. The .id of type CellStateId
member ensures that the geographic personality of a saved state can be matched to the cells of the model that you now keep in memory (a safeguard).</p>
<p>Let’s look more closely:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[23]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="k">def</span> <span class="nf">print_pub_attr</span><span class="p">(</span><span class="n">obj</span><span class="p">):</span>
    <span class="c1">#only public attributes</span>
    <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">obj</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="si">}</span><span class="s1">:</span><span class="se">\t</span><span class="s1">&#39;</span><span class="p">,[</span><span class="n">attr</span> <span class="k">for</span> <span class="n">attr</span> <span class="ow">in</span> <span class="nb">dir</span><span class="p">(</span><span class="n">obj</span><span class="p">)</span> <span class="k">if</span> <span class="n">attr</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">is</span> <span class="ow">not</span> <span class="s1">&#39;_&#39;</span><span class="p">])</span>

<span class="nb">print</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">init_state</span><span class="p">))</span>
<span class="n">init_state_cell0</span> <span class="o">=</span> <span class="n">init_state</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
<span class="c1"># the identifier</span>
<span class="n">print_pub_attr</span><span class="p">(</span><span class="n">init_state_cell0</span><span class="o">.</span><span class="n">id</span><span class="p">)</span>
<span class="c1"># gam snow states</span>
<span class="n">print_pub_attr</span><span class="p">(</span><span class="n">init_state_cell0</span><span class="o">.</span><span class="n">state</span><span class="o">.</span><span class="n">gs</span><span class="p">)</span>

<span class="c1">#init_state_cell0.kirchner states</span>
<span class="n">print_pub_attr</span><span class="p">(</span><span class="n">init_state_cell0</span><span class="o">.</span><span class="n">state</span><span class="o">.</span><span class="n">kirchner</span><span class="p">)</span>

</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
3874
CellStateId:     [&#39;area&#39;, &#39;cid&#39;, &#39;x&#39;, &#39;y&#39;]
GammaSnowState:  [&#39;acc_melt&#39;, &#39;albedo&#39;, &#39;alpha&#39;, &#39;iso_pot_energy&#39;, &#39;lwc&#39;, &#39;sdc_melt_mean&#39;, &#39;surface_heat&#39;, &#39;temp_swe&#39;]
KirchnerState:   [&#39;q&#39;]
</pre></div></div>
</div>
<div class="section" id="Summary">
<h4>Summary<a class="headerlink" href="#Summary" title="Permalink to this headline">¶</a></h4>
<p>We have now explored the <code class="docutils literal notranslate"><span class="pre">region_model</span></code> and looked at how to instantiate a <code class="docutils literal notranslate"><span class="pre">region_model</span></code> by using a <code class="docutils literal notranslate"><span class="pre">api.ARegionEnvironment</span></code>, containing a collection of timeseries sources, and passing an <code class="docutils literal notranslate"><span class="pre">api.InterpolationParameter</span></code> class containing the parameters to use for the data interpolation algorithms. The interpolation step “populated” our cells with data from the point sources.</p>
<p>The cells each contain all the information related to the simulation (their own timeseries, <code class="docutils literal notranslate"><span class="pre">env_ts</span></code>; their own model parameters, <code class="docutils literal notranslate"><span class="pre">parameter</span></code>; and other attributes and methods). In future tutorials we’ll work with the cells indivdual “resource collector” (<code class="docutils literal notranslate"><span class="pre">.rc</span></code>) and “state collector” (<code class="docutils literal notranslate"><span class="pre">.sc</span></code>) attributes.</p>
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../grid-pp/gridpp_geopoints.html" class="btn btn-neutral float-right" title="Demonstration of SHyFT API implementation of Kalman Filtering on gridded data" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="run_nea_nidelva.html" class="btn btn-neutral float-left" title="A first simulation with Shyft" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>